/// <reference types="react" />
import { IEntity } from '../../definitions.interface';
import { BaseList } from '../list';
import { IGridState } from './grid.interface';
import { IGridProps } from '../../definition';
export declare class Grid extends BaseList<IGridProps, IGridState> {
    static readonly defaultProps: IGridProps;
    /**
     * @stable [07.06.2018]
     * @param {IGridProps} originalProps
     */
    constructor(originalProps: IGridProps);
    /**
     * @stable [23.10.2019]
     * @returns {JSX.Element}
     */
    protected getView(): JSX.Element;
    /**
     * @stable [07.06.2018]
     * @returns {IEntity[]}
     */
    protected filterAndSortOriginalDataSourceUsingLocalFiltersAndSorters(): IEntity[];
    /**
     * @stable [06.06.2018]
     * @param {IFieldChangeEntity} payload
     */
    private onChangeRowField;
    /**
     * @stable [07.06.2018]
     * @param {IFieldChangeEntity} payload
     */
    private onChangeGroupingRowField;
    /**
     * @stable [07.06.2018]
     * @param {IFieldChangeEntity} payload
     */
    private onChangeFilterField;
    /**
     * @stable - 06.04.2018
     * @param {IGridColumnProps} column
     * @param {number} columnNum
     * @returns {React.ReactNode}
     */
    private getHeaderColumnContent;
    private readonly headRowElement;
    /**
     * @stable [07.06.2018]
     * @param {IEntity} entity
     * @param {IGridColumnProps} column
     * @param {number} columnNum
     * @param {number} rowNum
     * @param {IEntity[]} groupedRows
     * @returns {React.ReactNode}
     */
    private getColumn;
    /**
     * @stable [07.06.2018]
     * @param {IGridColumnProps} column
     * @param {number} columnNum
     * @returns {React.ReactNode}
     */
    private getFilterColumn;
    /**
     * @stable [06.12.2019]
     * @param {IGridRowConfigEntity} rowConfig
     * @returns {JSX.Element}
     */
    private getRow;
    /**
     * @stable [26.10.2019]
     * @returns {JSX.Element}
     */
    private readonly filterElement;
    /**
     * @stable [07.06.2018]
     * @param {string} name
     * @returns {AnyT}
     */
    private toFilterFieldValue;
    /**
     * @stable [07.06.2018]
     * @returns {IFieldProps2}
     */
    private getDefaultFieldProps;
    /**
     * @stable [07.06.2018]
     * @param {IEntity} entity
     * @param {IGridColumnProps} column
     * @param {number} columnNum
     * @returns {string}
     */
    private toFieldName;
    /**
     * @stable [07.06.2018]
     * @param {IGridColumnProps} column
     * @param {number} columnNum
     * @returns {string}
     */
    private toFilterFieldName;
    /**
     * @stable - 06.04.2018
     * @param {number} columnNum
     * @returns {string}
     */
    private toHeaderFieldName;
    /**
     * @stable - 05.04.2018
     * @param {number} columnNum
     * @returns {string}
     */
    private toFilterColumnKey;
    /**
     * @stable - 05.04.2018
     * @param {number} columnNum
     * @returns {string}
     */
    private toHeaderColumnKey;
    /**
     * @stable - 06.04.2018
     * @param {string} fieldName
     * @returns {AnyT}
     */
    private toFieldValue;
    /**
     * @stable - 06.04.2018
     * @param {string} fieldName
     * @returns {AnyT}
     */
    private toCheckboxFieldValue;
    /**
     * @stable [07.06.2018]
     * @param {JSX.Element} renderEl
     * @returns {boolean}
     */
    private isElementField;
    /**
     * @stable [10.10.2018]
     * @returns {IGridColumnProps[]}
     */
    private readonly columnsConfiguration;
    /**
     * @stable [27.12.2018]
     * @returns {string}
     */
    private toTotalRowKey;
    /**
     * @stable [05.10.2018]
     * @param {EntityIdT} groupRowValue
     * @param {number} columnNum
     * @returns {string}
     */
    private asGroupColumnKey;
    /**
     * @stable [27.12.2018]
     * @param {number} columnNum
     * @returns {string}
     */
    private toTotalColumnKey;
    private getGroupedRows;
    /**
     * @stable [29.07.2020]
     * @param config
     */
    private getGroupRow;
    /**
     * @stable [27.10.2019]
     * @returns {JSX.Element}
     */
    private readonly totalRowElement;
    /**
     * @stable [30.07.2020]
     * @param groupValue
     * @param expanded
     */
    private onExpandGroup;
    /**
     * @stable [28.07.2020]
     * @param closed
     */
    private onHeadColumnClose;
    /**
     * @stable [28.07.2020]
     */
    private onHeadColumnExpandAllGroups;
    /**
     * @stable [30.07.2020]
     * @param entity
     */
    private extractGroupValue;
    /**
     * @stable [30.07.2020]
     * @param groupRowValue
     */
    private isGroupExpanded;
    /**
     * @stable [30.07.2020]
     */
    private readonly isGrouped;
    /**
     * @stable [30.07.2020]
     */
    private readonly areGroupsReady;
    /**
     * @stable [16.06.2020]
     * @returns {boolean}
     */
    private readonly isExpandActionRendered;
    /**
     * @stable [29.07.2020]
     * @param groupRowValue
     */
    private asGroupRowKey;
}
