"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var generic_base_component_1 = require("../../base/generic-base.component");
var util_1 = require("../../../util");
var definition_1 = require("../../../definition");
var GridRow = /** @class */ (function (_super) {
    __extends(GridRow, _super);
    /**
     * @stable [19.07.2020]
     * @param {IGridRowProps} originalProps
     */
    function GridRow(originalProps) {
        var _this = _super.call(this, originalProps) || this;
        _this.onClick = _this.onClick.bind(_this);
        return _this;
    }
    /**
     * @stable [23.10.2019]
     * @returns {JSX.Element}
     */
    GridRow.prototype.render = function () {
        var _this = this;
        var originalProps = this.originalProps;
        var className = originalProps.className, filter = originalProps.filter, group = originalProps.group, hovered = originalProps.hovered, indexed = originalProps.indexed, onClick = originalProps.onClick, onGroupClick = originalProps.onGroupClick, partOfGroup = originalProps.partOfGroup, rawData = originalProps.rawData, selectable = originalProps.selectable, selected = originalProps.selected;
        var isSelectable = selectable && (group
            ? util_1.TypeUtils.isFn(onGroupClick)
            : util_1.TypeUtils.isFn(onClick)) && !util_1.isSyntheticEntity(rawData);
        var isHovered = hovered && isSelectable;
        return (React.createElement(definition_1.UniversalScrollableContext.Consumer, null, function (selectedElementClassName) { return (React.createElement("tr", __assign({ ref: _this.actualRef, className: util_1.ClsUtils.joinClassName(definition_1.GridClassesEnum.GRID_ROW, util_1.CalcUtils.calc(className), filter && definition_1.GridClassesEnum.GRID_ROW_FILTER, group && definition_1.GridClassesEnum.GRID_ROW_GROUP, indexed && !R.isNil(rawData) && "rac-grid-row-" + rawData.id, isHovered && 'rac-grid-row-hovered', isSelectable && definition_1.GridClassesEnum.GRID_ROW_SELECTABLE, originalProps.groupExpanded && 'rac-grid-row-group-expanded', originalProps.odd && 'rac-grid-row-odd', originalProps.total && 'rac-grid-row-total', partOfGroup && definition_1.GridClassesEnum.GRID_ROW_PART_OF_GROUP, selected && definition_1.GridClassesEnum.GRID_ROW_SELECTED + " " + selectedElementClassName) }, util_1.PropsUtils.buildClickHandlerProps(_this.onClick, isSelectable, false)), _this.originalChildren)); }));
    };
    /**
     * @stable [19.07.2020]
     */
    GridRow.prototype.onClick = function () {
        var _a = this.originalProps, group = _a.group, onClick = _a.onClick, onGroupClick = _a.onGroupClick, rawData = _a.rawData;
        if (group) {
            if (util_1.TypeUtils.isFn(onGroupClick)) {
                onGroupClick(rawData);
            }
        }
        else {
            if (util_1.TypeUtils.isFn(onClick)) {
                onClick(rawData);
            }
        }
    };
    GridRow.defaultProps = {
        hovered: true,
        selectable: true,
    };
    return GridRow;
}(generic_base_component_1.GenericBaseComponent));
exports.GridRow = GridRow;
//# sourceMappingURL=grid-row.component.js.map