"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var util_1 = require("../../../util");
var generic_base_component_1 = require("../../base/generic-base.component");
var definition_1 = require("../../../definition");
/**
 * @component-impl
 * @stable [01.06.2020]
 */
var ListItem = /** @class */ (function (_super) {
    __extends(ListItem, _super);
    /**
     * @stable [01.06.2020]
     * @param {IListItemProps} props
     */
    function ListItem(props) {
        var _this = _super.call(this, props) || this;
        _this.onClick = _this.onClick.bind(_this);
        return _this;
    }
    /**
     * @stable [01.06.2020]
     * @returns {JSX.Element}
     */
    ListItem.prototype.render = function () {
        var _this = this;
        var mergedProps = this.mergedProps;
        var index = mergedProps.index, rawData = mergedProps.rawData, renderer = mergedProps.renderer, tpl = mergedProps.tpl;
        return (React.createElement(definition_1.UniversalScrollableContext.Consumer, null, function (selectedElementClassName) {
            var itemProps = _this.getItemProps({ selectedElementClassName: selectedElementClassName }, mergedProps);
            return (util_1.TypeUtils.isFn(renderer)
                ? React.cloneElement(renderer(rawData, index), itemProps)
                : (React.createElement("li", __assign({}, itemProps),
                    util_1.WrapperUtils.isIconLeftAligned(mergedProps) && _this.getIconElement(mergedProps),
                    React.createElement("div", { className: definition_1.ListClassesEnum.LIST_ITEM_CONTENT }, util_1.TypeUtils.isFn(tpl)
                        ? tpl(rawData)
                        : _this.props.children),
                    !util_1.WrapperUtils.isIconLeftAligned(mergedProps) && _this.getIconElement(mergedProps))));
        }));
    };
    /**
     * @stable [01.06.2020]
     * @param {ISelectedElementClassNameWrapper} context
     * @param {IListItemProps} mergedProps
     * @returns {React.DetailedHTMLProps<React.HTMLAttributes<HTMLLIElement>, HTMLLIElement>}
     */
    ListItem.prototype.getItemProps = function (context, mergedProps) {
        var className = mergedProps.className, icon = mergedProps.icon, onClick = mergedProps.onClick;
        var selectedElementClassName = context.selectedElementClassName;
        var isSelectable = util_1.WrapperUtils.isSelectable(mergedProps);
        return (__assign({ ref: this.actualRef, className: util_1.ClsUtils.joinClassName.apply(util_1.ClsUtils, [definition_1.ListClassesEnum.LIST_ITEM,
                util_1.CalcUtils.calc(className),
                isSelectable && definition_1.ListClassesEnum.LIST_ITEM_SELECTABLE,
                icon && definition_1.ListClassesEnum.LIST_ITEM_DECORATED,
                util_1.WrapperUtils.isOdd(mergedProps) && definition_1.ListClassesEnum.LIST_ITEM_ODD,
                util_1.WrapperUtils.isHovered(mergedProps) && definition_1.ListClassesEnum.LIST_ITEM_HOVERED,
                util_1.WrapperUtils.isLast(mergedProps) && definition_1.ListClassesEnum.LIST_ITEM_LAST].concat((isSelectable && (util_1.WrapperUtils.isSelected(mergedProps)
                ? [definition_1.ListClassesEnum.LIST_ITEM_SELECTED, selectedElementClassName]
                : [definition_1.ListClassesEnum.LIST_ITEM_UNSELECTED])))) }, util_1.PropsUtils.buildClickHandlerProps(this.onClick, util_1.TypeUtils.isFn(onClick) && !util_1.WrapperUtils.isDisabled(mergedProps) && isSelectable, false)));
    };
    /**
     * @stable [01.06.2020]
     */
    ListItem.prototype.onClick = function () {
        var _a = this.mergedProps, onClick = _a.onClick, rawData = _a.rawData;
        onClick(rawData);
    };
    /**
     * @stable [01.06.2020]
     * @param {IListItemProps} mergedProps
     * @returns {JSX.Element}
     */
    ListItem.prototype.getIconElement = function (mergedProps) {
        var icon = mergedProps.icon;
        return (icon && this.uiFactory.makeIcon({
            type: icon,
            className: definition_1.ListClassesEnum.LIST_ITEM_ICON,
        }));
    };
    Object.defineProperty(ListItem.prototype, "settingsProps", {
        /**
         * @stable [02.06.2020]
         * @returns {IListItemProps}
         */
        get: function () {
            return this.componentsSettings.listItem;
        },
        enumerable: true,
        configurable: true
    });
    return ListItem;
}(generic_base_component_1.GenericBaseComponent));
exports.ListItem = ListItem;
//# sourceMappingURL=list-item.component.js.map