import { StoreProxy } from '../store.proxy';
import { IApiEntity, IDictionaryStoreProxy, IGenericContainer, IGenericContainerProps, IReduxStoreEntity } from '../../../../definition';
export declare class DictionaryStoreProxy<TStore extends IReduxStoreEntity = IReduxStoreEntity, TProps extends IGenericContainerProps = IGenericContainerProps> extends StoreProxy<TStore, TProps> implements IDictionaryStoreProxy {
    readonly container: IGenericContainer<TProps>;
    /**
     * @stable [30.03.2020]
     * @param {IGenericContainer<TProps extends IGenericContainerProps>} container
     */
    constructor(container: IGenericContainer<TProps>);
    /**
     * @stable [09.05.2020]
     * @param {string} dictionary
     * @param {IApiEntity} apiEntity
     */
    dispatchLoadDictionary(dictionary: string, apiEntity?: IApiEntity): void;
}
