import { IDefaultLayoutContainerProps, IFieldsContainer, IFilterFormDialogContainerProps, IFormContainerProps, IFormProps, IGenericBaseSelectEntity, IGenericContainer, IListContainerProps, IPageToolbarContainerProps, IPageToolbarProps, IPrimaryFilterExtendedFormEntity, ISearchToolbarContainerProps, ISearchToolbarProps, ISecondaryFilterExtendedFormEntity, ISecondaryFilterFormEntity, IToolbarToolsContainerProps, IToolbarToolsProps, IUnsavedFormChangesDialogContainerProps, IUnsavedFormChangesDialogProps } from '../definition';
import { IEntity } from '../definitions.interface';
/**
 * @stable [06.05.2020]
 */
export declare class ComponentMappers {
    static filterFormDialogContainerProps: (props: IFilterFormDialogContainerProps) => IFilterFormDialogContainerProps;
    static filterFormDialogSecondaryFilterContainerProps: (props: IFilterFormDialogContainerProps & ISecondaryFilterExtendedFormEntity<IEntity>) => IFilterFormDialogContainerProps;
    static formContainerProps: (props: IFormContainerProps<IEntity, {}>) => IFormContainerProps<IEntity, {}>;
    static formContainerPropsAsFormProps: (props: IFormContainerProps<IEntity, {}>) => IFormProps<IEntity>;
    static formPrimaryFilterContainerProps: (props: IFormContainerProps<IEntity, {}> & IPrimaryFilterExtendedFormEntity<IEntity>) => IFormContainerProps<IEntity, {}>;
    static listContainerProps: (props: IListContainerProps) => IListContainerProps;
    static pageToolbarContainerProps: (props: IPageToolbarContainerProps) => IPageToolbarContainerProps;
    static pageToolbarContainerPropsAsPageToolbarProps: (props: IPageToolbarContainerProps) => IPageToolbarProps;
    static placeFieldProps: (container: IFieldsContainer) => IGenericBaseSelectEntity;
    static readonly defaultLayoutContainerProps: (entity: IDefaultLayoutContainerProps) => IDefaultLayoutContainerProps;
    static readonly toolbarToolsContainerPropsAsToolbarToolsProps: (props: IToolbarToolsContainerProps<IToolbarToolsProps>) => IToolbarToolsProps;
    static readonly unsavedFormChangesDialogContainerProps: (props: IUnsavedFormChangesDialogContainerProps, proxyContainer: IGenericContainer<import("core/definition/generic-container-definition.interface").IGenericContainerProps<{}, any>, {}>) => IUnsavedFormChangesDialogContainerProps;
    static readonly unsavedFormChangesDialogContainerPropsAsUnsavedFormChangesDialogProps: (props: IUnsavedFormChangesDialogContainerProps) => IUnsavedFormChangesDialogProps;
    static searchToolbarContainerProps: (props: ISearchToolbarContainerProps) => ISearchToolbarContainerProps;
    static searchToolbarContainerPropsAsSearchToolbarProps: (props: ISearchToolbarContainerProps) => ISearchToolbarProps;
    static toolbarToolsContainerProps: (props: IToolbarToolsContainerProps<IToolbarToolsProps>) => IToolbarToolsContainerProps<IToolbarToolsProps>;
    static toolbarToolsSecondaryFilterContainerProps: (props: IToolbarToolsContainerProps<IToolbarToolsProps> & ISecondaryFilterFormEntity<IEntity>) => IToolbarToolsContainerProps<IToolbarToolsProps>;
}
