import { IDisabledWrapper, IEntity, IQueryWrapper, ISectionNameWrapper } from '../definitions.interface';
import { IExtendedEntity, IExtendedFormEntity, INamedEntity, IOptionEntity, IPresetsRawDataLabeledValueEntity, IPresetsSelectOptionEntity, IPrimaryFilterExtendedFormEntity, IReduxBaseSelectEntity, IReduxDictionariesEntity, IReduxDictionaryEntity, IReduxFormEntity, IReduxHolderDictionariesEntity, IReduxHolderFormEntity, IReduxHolderListEntity, IReduxHolderNotificationEntity, IReduxHolderPrimaryFilterFormEntity, IReduxHolderQueryFilterEntity, IReduxHolderSecondaryFilterFormEntity, IReduxHolderTransportEntity, IReduxHolderUserEntity, IReduxNotificationEntity, IReduxPagedEntity, IReduxPaginatedEntity, IReduxPaginatedLifeCycleEntity, IReduxQueryFilterEntity, IReduxStoreEntity, IReduxTransportEntity, IReduxUserEntity, ISecondaryFilterExtendedFormEntity, ISecondaryFilterFormEntity } from '../definition';
/**
 * @stable [06.05.2020]
 */
export declare class GenericMappers {
    static readonly dictionaryEntityAsSelectEntity: <TEntity, TResult = TEntity[]>(entity: IReduxDictionaryEntity<TEntity>, accessor?: (data: TEntity[]) => TResult) => IReduxBaseSelectEntity;
    static readonly dictionaryEntityAsSelectOptionEntities: <TEntity>(dictionaryEntity: IReduxDictionaryEntity<TEntity>, accessor?: (data: TEntity | TEntity[]) => any) => IPresetsSelectOptionEntity<TEntity, string | number>[];
    static readonly entityAsExtendedEntity: <TEntity extends IEntity = IEntity>(formEntity: IReduxFormEntity<TEntity>, entity?: TEntity) => IExtendedEntity<TEntity>;
    static readonly entityAsExtendedFormEntity: <TEntity = IEntity>(formEntity: IReduxFormEntity<TEntity>, entity?: TEntity) => IExtendedFormEntity<TEntity>;
    static readonly extendedEntity: <TEntity = IEntity>(extendedEntity: IExtendedEntity<TEntity>) => IExtendedEntity<TEntity>;
    static readonly fullSearchFilter: <TFilter, TEntity = IEntity>(wrapper: IReduxHolderQueryFilterEntity & IReduxHolderListEntity<TEntity, any, import("core/definition/list-definition.interface").IReduxListEntity<TEntity, any>>, cfg?: {
        paging: boolean;
    }) => TFilter;
    static readonly holderDictionariesEntity: <TEntity = IReduxDictionariesEntity>(wrapper: IReduxHolderDictionariesEntity<TEntity>) => IReduxHolderDictionariesEntity<TEntity>;
    static readonly holderFormEntity: <TEntity = IEntity>(entity: IReduxHolderFormEntity<TEntity>) => IReduxHolderFormEntity<TEntity>;
    static readonly holderListEntity: (entity: IReduxHolderListEntity<IEntity, any, import("core/definition/list-definition.interface").IReduxListEntity<IEntity, any>>) => IReduxHolderListEntity<IEntity, any, import("core/definition/list-definition.interface").IReduxListEntity<IEntity, any>>;
    static readonly holderListEntityAsDisabled: (listEntity: IReduxHolderListEntity<IEntity, any, import("core/definition/list-definition.interface").IReduxListEntity<IEntity, any>>) => IDisabledWrapper<boolean>;
    static readonly holderNotificationEntity: <TEntity = IReduxNotificationEntity>(entity: IReduxHolderNotificationEntity<TEntity>) => IReduxHolderNotificationEntity<TEntity>;
    static readonly holderQueryFilterEntity: (entity: IReduxHolderQueryFilterEntity) => IReduxHolderQueryFilterEntity;
    static readonly holderQueryFilterEntityAsQuery: (entity: IReduxHolderQueryFilterEntity) => IQueryWrapper<string>;
    static readonly holderTransportEntity: <TEntity = IReduxTransportEntity>(entity: IReduxHolderTransportEntity<TEntity>) => IReduxHolderTransportEntity<TEntity>;
    static readonly holderUserEntity: <TEntity = IReduxUserEntity>(wrapper: IReduxHolderUserEntity<TEntity>) => IReduxHolderUserEntity<TEntity>;
    static readonly listEntityAsPagedEntity: (entity: IReduxHolderListEntity<IEntity, any, import("core/definition/list-definition.interface").IReduxListEntity<IEntity, any>>, pageSize?: number) => IReduxPagedEntity;
    static readonly listSelectedEntityAsExtendedFormEntity: <TEntity = IEntity>(holderListEntity: IReduxHolderListEntity<TEntity, any, import("core/definition/list-definition.interface").IReduxListEntity<TEntity, any>>, formEntity: IReduxFormEntity<TEntity>) => IExtendedFormEntity<TEntity>;
    static readonly listSelectedExtendedFormEntityAsFinalEntity: <TEntity = IEntity>(listEntity: IReduxHolderListEntity<TEntity, any, import("core/definition/list-definition.interface").IReduxListEntity<TEntity, any>>, formEntity: IReduxFormEntity<TEntity>) => TEntity;
    static readonly namedEntityAsRawDataLabeledValueEntity: (entity: INamedEntity) => IPresetsRawDataLabeledValueEntity<IEntity, string | number>;
    static readonly optionEntitiesAsSelectOptionEntities: <TEntity extends IOptionEntity>(data: TEntity | TEntity[]) => IPresetsSelectOptionEntity<TEntity, string | number>[];
    static readonly pagedEntity: (entity: IReduxPagedEntity) => IReduxPagedEntity;
    static readonly paginatedEntity: (entity: IReduxPaginatedEntity) => IReduxPaginatedEntity;
    static readonly paginatedLifeCycleEntity: (entity: IReduxPaginatedLifeCycleEntity) => IReduxPaginatedLifeCycleEntity;
    static readonly primaryFilterEntityAsPrimaryFilterExtendedFormEntity: <TEntity = IEntity>(wrapper: IReduxHolderPrimaryFilterFormEntity<TEntity>, entity?: TEntity) => IPrimaryFilterExtendedFormEntity<TEntity>;
    static readonly queryFilterEntity: (entity: IReduxQueryFilterEntity) => IReduxQueryFilterEntity;
    static readonly secondaryFilterEntityAsSecondaryFilterExtendedFormEntity: <TEntity = IEntity>(wrapper: IReduxHolderSecondaryFilterFormEntity<TEntity>, entity?: TEntity) => ISecondaryFilterExtendedFormEntity<TEntity>;
    static readonly secondaryFilterFormEntityAsHolderFormEntity: <TEntity = IEntity>(entity: ISecondaryFilterFormEntity<TEntity>) => IReduxHolderFormEntity<TEntity>;
    static readonly sectionNameWrapper: (wrapper: ISectionNameWrapper) => ISectionNameWrapper;
    static readonly storeEntity: <TDictionaries = {}>(entity: IReduxStoreEntity<TDictionaries>) => IReduxStoreEntity<TDictionaries>;
}
